
StarWars = {}
StarWars.Settings = {}





StarWars.Settings.Granade = 1 -- Grenades with their own system
StarWars.Settings.ClearAmmo = 1 -- Weapons that are in the list will be automatically cleared of regular ammo
StarWars.Settings.EMPdamage = 1 -- Electrical pulses deal 1 damage?


-- Here instead of 'nil' you can insert your functions here

-- When the player takes damage
StarWars.Settings.function_hit = nil -- id, iid, dmg
-- When the bullet found the player. You can (should) return - false or true
StarWars.Settings.function_prehit = nil -- idimg, id, iid, dmg, id StarWars.Bullets

attackButton = "mouse1" -- Shooting
ReloadButton = "R" -- Reloading
addbind(attackButton)
addbind(ReloadButton)


-- 344 line - there are examples of how to customize weapons






StarWars.TIME1 = 0
StarWars.Weapons = {}
StarWars.Bullets = {}
StarWars.Players = {}
StarWars.Players.Weapons = {}
StarWars.DropedWeapons = {}
StarWars.Players.Keys = {}
StarWars.Players.Control = {}
StarWars.HUDS = {}
StarWars.IMG_EXPLOSION = {}
StarWars.SmokeStorm = {}
if true then
	parse('mp_hudscale 1')
	parse('mp_hud 119')
end

--addhook('attack','d123')
addhook('attack2','StarWars.a123')
addhook('always','StarWars.StarWars_alw')
addhook('startround_prespawn','StarWars.StarWars_startround_prespawn')

addhook('drop','StarWars.dr')
addhook('collect','StarWars.col')
addhook('key','StarWars.kea')
addhook('ms100','StarWars.mss')
addhook('second','StarWars.second123')
addhook('die','StarWars.die123')
addhook('leave','StarWars.leave123')
addhook('select','StarWars.select123')
addhook('projectile_impact','StarWars.projectile_impact123')
addhook('projectile','StarWars.projectile123')
function number_cheker(znach)
	if type(znach) == 'number' then
		return true
	end
	return false
end
--  ammo HUD
StarWars.HUDS.Hid = 0
StarWars.HUDS.X = 700
StarWars.HUDS.Y = 440
StarWars.HUDS[1] = {255,100,0}
StarWars.HUDS[2] = {0,100,255}
StarWars.HUDS.size = 40

StarWars.IMGReloadHud = "<spritesheet:gfx/StarWars/Reload.png:64:64:n>"
StarWars.XReloadHud = 420
StarWars.YReloadHud = 245
StarWars.SizeReloadHud = 2.2
StarWars.BlendReloadHud = 1
--------
StarWars.ArmorProcent = 0.5 -- Multiply damage taken by this number
-- Grenade settings
StarWars.HEimpuls_radius = 128
StarWars.HEimpuls_dmg = 20

StarWars.FLASHelec_radius = 96
StarWars.FLASHelec_dmgEMP = 25 -- armor damage

StarWars.SMOKEelec_radius = 64
StarWars.SMOKEelec_dmgEMP = 15 -- armor damage
StarWars.SMOKEelec_time = 180 -- Duration
-------- Sounds
StarWars.shot1 = "StarWars/shot1.wav" -- vint
StarWars.shot2 = "StarWars/shot2.wav" -- pistol
StarWars.shot3 = "StarWars/shot3.wav" -- m3
StarWars.shot4 = "StarWars/shot4.wav" -- xm
StarWars.shot5 = "StarWars/shot5.wav" -- vint
StarWars.shot6 = "StarWars/shot6.wav" -- scot
StarWars.shot7 = "StarWars/shot7.wav" -- AWP
StarWars.shot8 = "StarWars/shot8.wav" -- vint
StarWars.bam = "StarWars/bam.wav" -- bam
StarWars.elec = "StarWars/elec.wav"
StarWars.reload1 = "StarWars/reload.wav"
StarWars.reload2 = "StarWars/reload1.wav"
StarWars.hit = "StarWars/hit.wav"
--------

function StarWars:Rasto(x1, y1, x2, y2)
	return math.sqrt((x2 - x1)^2 + (y2 - y1)^2)
end
function StarWars:AtanBuch(Ax, Ay, Bx, By)
	local x = Bx - Ax
	local y = By - Ay

	local angle = math.atan2(y, x)
	return angle
end
function StarWars:Fov_real(angle)
	return (angle * 180 / math.pi)
end
function StarWars:ChekerWall(x,y,xx,yy)
	 local angl = StarWars:AtanBuch(x,y,xx,yy)
	 local proch = 16
	for ii = 1, StarWars:Rasto(x,y,xx,yy) do
		local X1 = x + math.cos(angl) * ii
		local Y1 = y + math.sin(angl) * ii
		
		if tile(math.ceil(X1/32)-1,math.ceil(Y1/32)-1,"wall") and proch <= 0 then
			return false
		elseif tile(math.ceil(X1/32)-1,math.ceil(Y1/32)-1,"wall") then
			proch = proch - 1
		end
	end
	return true
end
function StarWars.IMG_EXPLOSION:init()
	for ke, val in pairs(StarWars.IMG_EXPLOSION) do
		if number_cheker(ke) then
			StarWars.IMG_EXPLOSION[ke] = nil
		end
	end
end
function StarWars.IMG_EXPLOSION:Explosion(tip,x,y,dmg,size,id,RBG)
	if tip == 1 then
		for k, va in pairs(closeplayers(x,y,size)) do
			if ((game('sv_gamemode') == '1' and id ~= va) or (player(id,'team') ~= player(va,'team'))) and StarWars:ChekerWall(x,y,player(va,'x'),player(va,'y')) then
				StarWars.Players:hurt(va,id,dmg)
				parse('shake '..va..' '..dmg)
			end
		end
		for k, va in pairs(closeobjects(x,y,size)) do
			if (object(va,'type') ~= 40) and StarWars:ChekerWall(x,y,object(va,'x'),object(va,'y')) then
				StarWars.ObjectHurt(va,id,dmg)
			end
		end
		--parse('effect "fire" '..x..' '..y..' 32 '..size)
		parse('sv_soundpos "'..StarWars.bam..'" '..x..' '..y)
		
		local imgh = image('gfx/StarWars/bam.png',x,y,1)
		
		imagescale(imgh,0.3,0.3)
		imagecolor(imgh,RBG[1],RBG[2],RBG[3])
		imageblend(imgh,1)
		tween_alpha(imgh,300,0.0)
		tween_scale(imgh,300,0.5+(size*0.01),0.5+(size*0.01))
		StarWars.IMG_EXPLOSION[#StarWars.IMG_EXPLOSION+1] = {imgh,30}
	elseif tip == 2 then
		for k, va in pairs(closeplayers(x,y,size)) do
			if ((game('sv_gamemode') == '1' and id ~= va) or (player(id,'team') ~= player(va,'team'))) then
				StarWars.Players:hurt_Armor(va,dmg)
				if StarWars.Settings.EMPdamage == 1 then
					StarWars.Players:hurt(va,id,1)
					parse('shake '..va..' '..(dmg*0.4))
					parse('flashplayer '..va..' '..dmg)
				end
			end
		end
		for k, va in pairs(closeobjects(x,y,size)) do
			if (object(va,'type') ~= 40) then
				StarWars.ObjectHurt(va,id,dmg*0.5)
			end
		end
		parse('sv_soundpos "'..StarWars.elec..'" '..x..' '..y)
		
		local imgh = image('gfx/StarWars/elec.png',x,y,1)
		
		imagepos(imgh,x,y,math.random(0,360))
		imagescale(imgh,0.3,0.3)
		imagecolor(imgh,RBG[1],RBG[2],RBG[3])
		imageblend(imgh,1)
		tween_alpha(imgh,300,0.0)
		tween_scale(imgh,300,0.5+(size*0.01),0.5+(size*0.01))
		StarWars.IMG_EXPLOSION[#StarWars.IMG_EXPLOSION+1] = {imgh,30}
	end
end
function StarWars.IMG_EXPLOSION:timers()
	for ke, val in pairs(StarWars.IMG_EXPLOSION) do
		if number_cheker(ke) then
			if StarWars.IMG_EXPLOSION[ke][2] > 0 then
				StarWars.IMG_EXPLOSION[ke][2] = StarWars.IMG_EXPLOSION[ke][2] - 1
				if StarWars.IMG_EXPLOSION[ke][2] <= 0 then
					freeimage(StarWars.IMG_EXPLOSION[ke][1])
					StarWars.IMG_EXPLOSION[ke] = nil
				end
			end
		end
	end
end
function StarWars.SmokeStorm:SmokeActivator(x,y,id)
	local gg = #StarWars.SmokeStorm+1
	StarWars.SmokeStorm[gg] = {}
	StarWars.SmokeStorm[gg].id = id
	StarWars.SmokeStorm[gg].X = x
	StarWars.SmokeStorm[gg].Y = y
	StarWars.SmokeStorm[gg].timers = StarWars.SMOKEelec_time
	StarWars.SmokeStorm[gg].bam = 1
end
function StarWars.SmokeStorm:timeSmoke() 
	for ke, val in pairs(StarWars.SmokeStorm) do
		if number_cheker(ke) then
			if StarWars.SmokeStorm[ke].bam > 0 then
				StarWars.SmokeStorm[ke].bam = StarWars.SmokeStorm[ke].bam - 1
				if StarWars.SmokeStorm[ke].bam <= 0 then
					StarWars.SmokeStorm[ke].bam = 10
					StarWars.IMG_EXPLOSION:Explosion(2,StarWars.SmokeStorm[ke].X,StarWars.SmokeStorm[ke].Y,StarWars.SMOKEelec_dmgEMP,StarWars.SMOKEelec_radius,StarWars.SmokeStorm[ke].id,{0,255,255})
					parse('effect "sparkles" '..StarWars.SmokeStorm[ke].X..' '..StarWars.SmokeStorm[ke].Y..' 50 0 0 255 255')
				end
			end
			if StarWars.SmokeStorm[ke].timers > 0 then
				StarWars.SmokeStorm[ke].timers = StarWars.SmokeStorm[ke].timers - 1
				if StarWars.SmokeStorm[ke].timers <= 0 then
					StarWars.SmokeStorm[ke] = nil
				end
			end
		end
	end
end
function StarWars.SmokeStorm:clear()
	for ke, val in pairs(StarWars.SmokeStorm) do
		if number_cheker(ke) then
			
			StarWars.SmokeStorm[ke] = nil
				
		end
	end
end
function StarWars.Players:hurt_Armor(id,dmg)
	if player(id,'armor') > 0 and player(id,'armor') <= 200 then
		local res = player(id,'armor') - dmg
		if res < 0 then
			res = 0
		end
		parse('setarmor '..id..' '..res)
	end
end
function StarWars.HUDS:update(id)
	if player(id,'health') > 0 then
		local oki = false
		for ke, val in pairs(StarWars.Weapons) do
				if number_cheker(ke) then
				
				for k, v in pairs(StarWars.Players.Weapons[id]) do
					if StarWars.Players.Weapons[id][k].Weaid == StarWars.Weapons[ke].Wea and player(id,'weapontype') == StarWars.Weapons[ke].Wea then
						if StarWars.Weapons[ke].typeWep == 0 then
							local ed = StarWars.Players.Weapons[id][k].Ammo..'/'..StarWars.Players.Weapons[id][k].Pocket
							
							parse('hudtxt2 '..id..' '..StarWars.HUDS.Hid..' "'..ed..'" '..StarWars.HUDS.X..' '..StarWars.HUDS.Y..' 0 0 '..StarWars.HUDS.size)
						else
							parse('hudtxt2 '..id..' '..StarWars.HUDS.Hid..' "'..string.sub(100/StarWars.Players.Weapons[id][k].Pocket*StarWars.Players.Weapons[id][k].Ammo,1,3)..'%" '..StarWars.HUDS.X..' '..StarWars.HUDS.Y..' 0 0 '..StarWars.HUDS.size)
						end
						parse('hudtxtcolorfade '..id..' '..StarWars.HUDS.Hid..' 1 '..StarWars.HUDS[player(id,'team')][1]..' '..StarWars.HUDS[player(id,'team')][2]..' '..StarWars.HUDS[player(id,'team')][3])
						oki = true
						break
					end
				end
				
			end
		end
		if oki == false then
			parse('hudtxt2 '..id..' '..StarWars.HUDS.Hid..' "" '..StarWars.HUDS.X..' '..StarWars.HUDS.Y..' 0 0 '..StarWars.HUDS.size)
		end
	else
		parse('hudtxt2 '..id..' '..StarWars.HUDS.Hid..' "" '..StarWars.HUDS.X..' '..StarWars.HUDS.Y..' 0 0 '..StarWars.HUDS.size)
	end
end

function StarWars.Weapons:edits(id_wea,coll,rec,toch,tipPat,tipPul,RBG,drobaw,mmods,relTime,bz,sod)
	local kluh = nil
	for ke, val in pairs(self) do
		if number_cheker(ke) then
			if id_wea == self[ke].Wea then
				kluh = ke
				break
			end
		end
	end
	if not kluh then
		kluh = #self+1
	end
	
	self[kluh] = {}
	self[kluh].Wea = id_wea
	self[kluh].Cooldown = coll
	self[kluh].Recoil = rec
	
	
	self[kluh].accuracy = toch
	self[kluh].typeWep = tipPat[1]
	self[kluh].Score = tipPat[2]
	self[kluh].Pocket = tipPat[3]
	
	self[kluh].DMG = tipPul[1]
	self[kluh].Speed = tipPul[2]
	self[kluh].Size = tipPul[3]
	
	self[kluh].R = RBG[1]
	self[kluh].B = RBG[2]
	self[kluh].G = RBG[3]
	
	--self[kluh].Bam = BZRUV
	
	self[kluh].shotgun = drobaw
	if mmods then
		self[kluh].Mmode = mmods[1]
		self[kluh].Mshotgun = mmods[2]
		self[kluh].Maccuracy = mmods[3]
		self[kluh].Mcooldown = mmods[4]
		self[kluh].Mspeed = mmods[5]
		self[kluh].Mdmg = mmods[6]
	end
	self[kluh].realoadTime = relTime

	self[kluh].explo = bz[1]
	self[kluh].exDMG = bz[2]
	self[kluh].exSize = bz[3]
	
	self[kluh].sound = sod
	
end
--[[
Examples of how to create settings for weapons
1 - Weapon that has the second mod
2 - Weapon that do not have a second mod
Examples of weapons below
]]
-- 1. StarWars.Weapons:edits(id_weapon, cooldown_shot, recoil, Accuracy, {energy_weapon, Ammo, spare_ammo}, {DMG, speed_bullet, size_bullet},{R,B,G}, bullets_one_shot, 
--  {different_mode, bullets_one_shot, Accuracy,cooldown_shot, speed_bullet, DMG}, realoadTime, {Explosion_mode, DMG, Size}, sound)

-- 2. StarWars.Weapons:edits(id_weapon, cooldown_shot, recoil, Accuracy, {energy_weapon, Ammo, spare_ammo}, {DMG, speed_bullet, size_bullet},{R,B,G}, bullets_one_shot, 
--  _, realoadTime, {Explosion_mode, DMG, Size}, sound)

-- Weapons that will not be listed will remain the same, ammo will not be removed from them
-----------------------------------
StarWars.Weapons:edits(1,10,0,5,{0,15,120},{30,18000,3.0},{0,155,255},1,{1,1,1,30,15000,30},30,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(2,10,0,5,{0,25,120},{25,18000,3.0},{255,155,0},1,{1,3,15,15,18000,20},40,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(3,30,0,0,{0,6,16},{30,15000,3.0},{255,255,0},1,_,50,{1,20,48},StarWars.shot5)
StarWars.Weapons:edits(4,20,0,3,{60,240,240},{20,17000,3.0},{0,255,255},1,_,0,{2,25,64},StarWars.shot2)
StarWars.Weapons:edits(5,15,0,1,{0,10,60},{40,17000,3.0},{0,255,0},1,_,40,{0,0,0},StarWars.shot4)
StarWars.Weapons:edits(6,5,0,8,{40,500,500},{20,19000,3.0},{155,0,255},1,_,0,{0,0,0},StarWars.shot2)

StarWars.Weapons:edits(10,50,0,10,{0,5,30},{30,22000,3.0},{0,255,0},5,_,50,{0,0,0},StarWars.shot3)
StarWars.Weapons:edits(11,15,0,20,{70,500,500},{20,22000,3.0},{155,0,255},5,_,50,{0,0,0},StarWars.shot4)

StarWars.Weapons:edits(20,5,0,6,{0,30,150},{25,18000,2.5},{255,255,0},1,_,50,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(21,3,0,10,{15,250,250},{15,20000,2.0},{0,155,255},1,_,30,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(22,2,0,7,{0,50,250},{10,20000,2.0},{155,255,0},1,_,60,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(23,3,0,10,{0,30,120},{15,20000,2.0},{255,155,0},1,_,40,{0,0,0},StarWars.shot2)
StarWars.Weapons:edits(24,10,0,3,{60,500,500},{20,17000,2.5},{0,255,255},1,_,40,{2,15,48},StarWars.shot2)

StarWars.Weapons:edits(30,5,0,5,{0,30,100},{35,16000,3.0},{255,155,0},1,_,50,{0,0,0},StarWars.shot1)
StarWars.Weapons:edits(32,5,0,4,{0,30,100},{35,16000,3.0},{0,155,255},1,{1,1,2,10,14000,35},60,{0,0,0},StarWars.shot1)
StarWars.Weapons:edits(38,6,0,3,{0,50,100},{25,16000,3.0},{255,155,0},1,_,70,{0,0,0},StarWars.shot1)
StarWars.Weapons:edits(39,6,0,2,{0,30,100},{30,16000,3.0},{0,155,255},1,{1,3,20,10,18000,25},60,{0,0,0},StarWars.shot1)
StarWars.Weapons:edits(33,13,0,1,{0,25,50},{45,15000,3.0},{0,200,255},1,_,75,{0,0,0},StarWars.shot8)
StarWars.Weapons:edits(31,13,0,1,{0,20,50},{45,16000,3.0},{255,255,0},1,_,60,{0,0,0},StarWars.shot8)

StarWars.Weapons:edits(34,60,0,0,{0,10,30},{60,15000,3.0},{155,255,0},1,_,60,{0,0,0},StarWars.shot6)
StarWars.Weapons:edits(35,120,0,0,{0,5,20},{70,14000,3.5},{255,255,255},1,_,70,{1,35,48},StarWars.shot7)
StarWars.Weapons:edits(36,25,0,2,{0,15,50},{30,16000,3.3},{255,255,0},1,_,110,{1,30,96},StarWars.shot6)
StarWars.Weapons:edits(37,25,0,2,{0,25,50},{30,16000,3.3},{0,255,255},1,_,110,{2,30,96},StarWars.shot6)

StarWars.Weapons:edits(91,4,0,3,{0,50,200},{40,15000,3.0},{255,255,255},1,_,60,{1,10,32},StarWars.shot5)
StarWars.Weapons:edits(90,0,0,15,{0,600,1200},{10,20000,2.0},{255,255,155},1,_,160,{0,0,0},StarWars.shot2)

StarWars.Weapons:edits(40,2,0,15,{0,200,200},{15,20000,2.0},{255,255,0},1,_,140,{0,0,0},StarWars.shot2)
--=========
--StarWars.Weapons:edits(10,15,0,10,{0,30,120},{30,18000,3.0},{255,0,0},5,_,60,{0,0,0},StarWars.shot1)
--StarWars.Weapons:edits(34,15,0,10,{0,30,120},{30,18000,3.0},{255,0,0},5,_,60,{0,0,0},StarWars.shot3)

function StarWars.Players:shoot(id)
	for ke, val in pairs(StarWars.Weapons) do
		if number_cheker(ke) then
		
			local iidd = 0
			for k, v in pairs(StarWars.Players.Weapons[id]) do
				if StarWars.Players.Weapons[id][k].Weaid == StarWars.Weapons[ke].Wea then
					iidd = k
					
					break
				end
			end
			
			
			if iidd ~= 0 and player(id,'weapontype') == StarWars.Weapons[ke].Wea and StarWars.Players.Control[id].cooldown <= 0 and StarWars.Players.Weapons[id][iidd].Ammo > StarWars.Weapons[ke].typeWep then
			
				parse('sv_soundpos "'..StarWars.Weapons[ke].sound..'" '..player(id,'x')..' '..player(id,'y'))
				if player(id,'weaponmode') == 0 then
					
					if StarWars.Weapons[ke].typeWep > 0 then
						StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - StarWars.Weapons[ke].typeWep
					else
						StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - 1
					end
					if StarWars.Players.Weapons[id][iidd].Ammo <= 0 then
						StarWars.Players.Weapons[id][iidd].Ammo = 0
					end
					
					for i = 1, StarWars.Weapons[ke].shotgun do
						local recci = StarWars.Players.Control[id].recoil * 0.5
						local randw = math.random(-StarWars.Weapons[ke].accuracy-recci,StarWars.Weapons[ke].accuracy+recci)
						
						local roi = player(id,'rot')+randw
						StarWars.Bullets:add_bullet(player(id,'x'),player(id,'y'),roi,
						StarWars.Weapons[ke].Speed,StarWars.Weapons[ke].DMG,id,{StarWars.Weapons[ke].R,StarWars.Weapons[ke].B,StarWars.Weapons[ke].G},StarWars.Weapons[ke].Size,920,{StarWars.Weapons[ke].explo,StarWars.Weapons[ke].exDMG,StarWars.Weapons[ke].exSize})
					end
					StarWars.Players.Control[id].recoil = StarWars.Players.Control[id].recoil + StarWars.Weapons[ke].Recoil
					StarWars.Players.Control[id].cooldown = StarWars.Weapons[ke].Cooldown
				elseif player(id,'weaponmode') >= 1 then
				
					if StarWars.Weapons[ke].Mmode then
						
						for i = 1, StarWars.Weapons[ke].Mshotgun do
							if StarWars.Players.Weapons[id][iidd].Ammo <= 0 then
								
								break
							end
							
							if StarWars.Weapons[ke].typeWep > 0 then
								StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - StarWars.Weapons[ke].typeWep
							else
								StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - 1
							end
							if StarWars.Players.Weapons[id][iidd].Ammo <= 0 then
								StarWars.Players.Weapons[id][iidd].Ammo = 0
							end
							
							local recci = StarWars.Players.Control[id].recoil * 0.5
							local randw = math.random(-StarWars.Weapons[ke].Maccuracy-recci,StarWars.Weapons[ke].Maccuracy+recci)
							
							local roi = player(id,'rot')+randw
							StarWars.Bullets:add_bullet(player(id,'x'),player(id,'y'),roi,
							StarWars.Weapons[ke].Mspeed,StarWars.Weapons[ke].Mdmg,id,{StarWars.Weapons[ke].R,StarWars.Weapons[ke].B,StarWars.Weapons[ke].G},StarWars.Weapons[ke].Size,920,{StarWars.Weapons[ke].explo,StarWars.Weapons[ke].exDMG,StarWars.Weapons[ke].exSize})
						end
						StarWars.Players.Control[id].recoil = StarWars.Players.Control[id].recoil + StarWars.Weapons[ke].Recoil
						StarWars.Players.Control[id].cooldown = StarWars.Weapons[ke].Mcooldown
						
					else
						
						if StarWars.Weapons[ke].typeWep > 0 then
							StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - StarWars.Weapons[ke].typeWep
						else
							StarWars.Players.Weapons[id][iidd].Ammo = StarWars.Players.Weapons[id][iidd].Ammo - 1
						end
						if StarWars.Players.Weapons[id][iidd].Ammo <= 0 then
							StarWars.Players.Weapons[id][iidd].Ammo = 0
						end
						
						for i = 1, StarWars.Weapons[ke].shotgun do
							local recci = StarWars.Players.Control[id].recoil * 0.5
							local randw = math.random(-StarWars.Weapons[ke].accuracy-recci,StarWars.Weapons[ke].accuracy+recci)
							
							local roi = player(id,'rot')+randw
							StarWars.Bullets:add_bullet(player(id,'x'),player(id,'y'),roi,
							StarWars.Weapons[ke].Speed-(player(id,'weaponmode')*3000),(StarWars.Weapons[ke].DMG*(player(id,'weaponmode')+1))*0.6,id,{StarWars.Weapons[ke].R,StarWars.Weapons[ke].B,StarWars.Weapons[ke].G},StarWars.Weapons[ke].Size,920,{StarWars.Weapons[ke].explo,StarWars.Weapons[ke].exDMG,StarWars.Weapons[ke].exSize})
						end
						StarWars.Players.Control[id].recoil = StarWars.Players.Control[id].recoil + StarWars.Weapons[ke].Recoil
						StarWars.Players.Control[id].cooldown = StarWars.Weapons[ke].Cooldown
					end
				end
				StarWars.HUDS:update(id)
				StarWars.Players.Control:Reload_clear(id)
				break
			end
		end
	end
end
--[[function StarWars.Players.Weapons:Switch_mode(id,mod,wea)
	for ke, val in pairs(StarWars.Players.Weapons[id]) do
		if wea == StarWars.Players.Weapons[id][ke].Weaid then
			
		end
	end
end]]
function StarWars.Bullets:clear(tip)
	if tip then
		for ke ,val in pairs(self) do
			if number_cheker(ke) then
				self:del(ke)
			end
		end
	else
		self = {}
	end
end
function StarWars.Bullets:add_bullet(x,y,rott,speed,dmg,id_plyaer,rbg,size,timeDest,explo)
	local rot = rott
	if (rot < -90) then rot = rot + 360 end
	local ang = math.rad(math.abs(rot + 90 )) - math.pi
	local xx = x
	local yy = y
	local X = xx + math.cos(ang) * 11800
	local Y = yy + math.sin(ang) * 11800
	local imgh = image('gfx/StarWars/bullet.png',xx,yy,1)
	
	imagepos(imgh,xx,yy,rot+90)
	tween_move(imgh,speed,X,Y)
	imagescale(imgh,size,size)
	imagecolor(imgh,rbg[1],rbg[2],rbg[3])
	imageblend(imgh,1)
	local ooo = #self+1
	self[ooo] = {imgh,dmg,id_plyaer,timeDest,explo,{rbg[1],rbg[2],rbg[3]}}
	self[ooo].old_x = xx
	self[ooo].old_y = yy
	
end
function StarWars.Bullets:logic()
	
	for ke, val in pairs(self) do
		
		if number_cheker(ke) and self[ke][4] > 0 then
			
			if not object(self[ke][1],'x') and not object(self[ke][1],'y') then
				StarWars.Bullets:del(ke)
			end
			if self[ke] then
			-- gg
				local angl = StarWars:AtanBuch(self[ke].old_x,self[ke].old_y,object(self[ke][1],'x'),object(self[ke][1],'y'))
				 local ostX = object(self[ke][1],'x')
				 local ostY = object(self[ke][1],'y')
				for ii = 1, StarWars:Rasto(self[ke].old_x,self[ke].old_y,ostX,ostY) do
					local X1 = self[ke].old_x + math.cos(angl) * ii
					local Y1 = self[ke].old_y + math.sin(angl) * ii
			
					for k, va in pairs(closeplayers(X1,Y1,20)) do
						if  (not StarWars.Settings.function_prehit or StarWars.Settings.function_prehit(self[ke][1],va,self[ke][3],self[ke][2],ke)) and ((game('sv_gamemode') == '1' and self[ke][3] ~= va) or (player(self[ke][3],'team') ~= player(va,'team'))) then
							StarWars.Players:hurt(va,self[ke][3],self[ke][2])
							parse('shake '..va..' '..(self[ke][2]*0.5))
							parse('flashplayer '..va..' '..(self[ke][2]*0.3))
							self[ke][4] = 0
						end
					end
						local vac = objectat(math.ceil(X1/32)-1,math.ceil(Y1/32)-1)
						local typ = object(vac,'type')
						
						if (typ and typ ~= false) and ((typ >= 3 and typ <= 5) or (typ >= 7 and typ <= 12) or (typ == 15) or (typ == 30)) then
							StarWars.ObjectHurt(vac,self[ke][3],self[ke][2])
							self[ke][4] = 0
						end
					
					--objectat
					if tile(math.ceil(X1/32)-1,math.ceil(Y1/32)-1,'wall') then
						self[ke][4] = 0
						parse('damagetile '..(math.ceil(X1/32)-1)..' '..(math.ceil(Y1/32)-1)..' '..self[ke][2])
					end
					if self[ke][4] <= 0 then
						ostX = X1
						ostY = Y1
						break
					end
				end
				self[ke][4] = self[ke][4] - 1
				self[ke].old_x = object(self[ke][1],'x')
				self[ke].old_y = object(self[ke][1],'y')
				if self[ke][4] <= 0 then
					parse('effect "sparkles" '..ostX..' '..ostY..' 50 0 '..self[ke][6][1]..' '..self[ke][6][2]..' '..self[ke][6][3])
					parse('sv_soundpos "'..StarWars.hit..'" '..ostX..' '..ostY)
					StarWars.IMG_EXPLOSION:Explosion(self[ke][5][1],ostX,ostY,self[ke][5][2],self[ke][5][3],self[ke][3],self[ke][6])
					StarWars.Bullets:del(ke)
				end
			end
		end
	end
end
function StarWars.Bullets:del(id)
	if object(StarWars.Bullets[id][1],'exists') then
		freeimage(StarWars.Bullets[id][1])
	end
	
	StarWars.Bullets[id] = nil
	
end
function StarWars.Players.Keys:press(id,key,stat)
	if key == attackButton and stat == 1 then
		self[id].attackState = true
	elseif	key == attackButton and stat == 0 then
		self[id].attackState = false
	end
	
	if key == ReloadButton and stat == 1 then
		
		 StarWars.Players.Control:Reload(id)
	
	end
end
-- StarWars.Players.Control



function StarWars.Players.Control:Add_hud_reload(id,timereload)
	if self[id].reloadHUD_IMG == 0 then
		self[id].reloadHUDMAX = timereload
		self[id].reloadHUD_IMG = image(StarWars.IMGReloadHud, StarWars.XReloadHud, StarWars.YReloadHud,2,id)
		imagecolor(self[id].reloadHUD_IMG, StarWars.HUDS[player(id,'team')][1],StarWars.HUDS[player(id,'team')][2],StarWars.HUDS[player(id,'team')][3])
		imagescale(self[id].reloadHUD_IMG, StarWars.SizeReloadHud, StarWars.SizeReloadHud)
		imageblend(self[id].reloadHUD_IMG,StarWars.BlendReloadHud)
		--imagealpha(self[id].reloadHUD_IMG,1.0)
	end
end
function StarWars.Players.Control:HUD_reload_progress()
	for ke, val in pairs(player(0,'table')) do
		if self[val].reloadHUD_IMG ~= 0 then
			if self[val].reload > 0 and object(self[val].reloadHUD_IMG,'exists') then
				local proc = 100 / self[val].reloadHUDMAX * self[val].reload
				if proc > 75 then
				
				elseif proc > 50 then
					if self[val].reloadHUDdev ~= 2 then
						self[val].reloadHUDdev = 2
						imageframe(self[val].reloadHUD_IMG,self[val].reloadHUDdev)
					end
				elseif proc > 25 then
					if self[val].reloadHUDdev ~= 3 then
						self[val].reloadHUDdev = 3
						imageframe(self[val].reloadHUD_IMG,self[val].reloadHUDdev)
					end
				elseif proc > 5 then
					if self[val].reloadHUDdev ~= 4 then
						self[val].reloadHUDdev = 4
						imageframe(self[val].reloadHUD_IMG,self[val].reloadHUDdev)
					end
				end
			else
				if object(self[val].reloadHUD_IMG,'exists') then
					freeimage(self[val].reloadHUD_IMG)
				end
				self[val].reloadHUD_IMG = 0
				self[val].reloadHUDMAX = 0
				self[val].reloadHUDdev = 0
			end
		end
	end
end
function StarWars.Players.Control:Reload_clear(id)
	StarWars.Players.Control[id].reload = 0
	StarWars.Players.Control[id].weapon = 0
end
function StarWars.Players.Control:Reload(id)
	for ke, val in pairs(StarWars.Players.Weapons[id]) do
		if number_cheker(ke) and player(id,'weapontype') == StarWars.Players.Weapons[id][ke].Weaid and StarWars.Players.Control[id].reload <= 0 then
			local iid = 0
			for k, va in pairs(StarWars.Weapons) do
				if number_cheker(k) then
					if StarWars.Players.Weapons[id][ke].Weaid == StarWars.Weapons[k].Wea then
						iid = k
						break
					end
				end
			end
			if iid ~= 0 and StarWars.Weapons[iid].typeWep == 0 and StarWars.Players.Weapons[id][ke].Pocket > 0 then
				if StarWars.Players.Weapons[id][ke].Ammo < StarWars.Weapons[iid].Score then
					StarWars.Players.Control[id].reload = StarWars.Weapons[iid].realoadTime
					StarWars.Players.Control[id].weapon = player(id,'weapontype')
					
					--self[id].reloadHUDMAX = StarWars.Weapons[iid].realoadTime
					StarWars.Players.Control:Add_hud_reload(id,StarWars.Weapons[iid].realoadTime)
					parse('sv_soundpos "'..StarWars.reload1..'" '..player(id,'x')..' '..player(id,'y'))
				end
			end
			
			break
			
		end
	end
end
function StarWars.Players.Control:Reload_progress()
	for ke, val in pairs(player(0,'tableliving')) do
	
		for k, va in pairs(StarWars.Players.Weapons[val]) do
			if number_cheker(k) then
			
				local id = false
				--
				for ka, vaa in pairs(StarWars.Weapons) do
					if number_cheker(ka) then
						if StarWars.Players.Weapons[val][k].Weaid == StarWars.Weapons[ka].Wea then
							id = ka
							break
						end
					end
				end
				if id and StarWars.Weapons[id].typeWep > 0 then
					if StarWars.Players.Weapons[val][k].Ammo < StarWars.Players.Weapons[val][k].Pocket then
						StarWars.Players.Weapons[val][k].Ammo = StarWars.Players.Weapons[val][k].Ammo + 1
						if StarWars.TIME1 <= 0 then
							StarWars.HUDS:update(val)
						end
					end
				end
			end
		end
		
		if self[val].reload > 0 then
			if player(val,'weapontype') ~= self[val].weapon then
				self[val].reload = 0
				self[val].weapon = 0
				
			else
				self[val].reload = self[val].reload - 1
				
				if self[val].reload <= 0 then
					local id = 0
					--
					for k, va in pairs(StarWars.Weapons) do
						if number_cheker(k) then
							if player(val,'weapontype') == StarWars.Weapons[k].Wea then
								id = k
								break
							end
						end
					end
					--
					local iidd = 0
					for k, va in pairs(StarWars.Players.Weapons[val]) do
						if number_cheker(k) then
							if player(val,'weapontype') == StarWars.Players.Weapons[val][k].Weaid then
								iidd = k
							end
						end
					end
					--
					
					local newAmo = StarWars.Players.Weapons[val][iidd].Ammo
					local estAmo = StarWars.Players.Weapons[val][iidd].Pocket
					local maxAmo = StarWars.Weapons[id].Score
					while maxAmo > newAmo and estAmo > 0 do
						estAmo = estAmo - 1
						newAmo = newAmo + 1
					end
					StarWars.Players.Weapons[val][iidd].Ammo = newAmo
					StarWars.Players.Weapons[val][iidd].Pocket = estAmo
					
					self[val].weapon = 0
					StarWars.HUDS:update(val)
					parse('sv_soundpos "'..StarWars.reload2..'" '..player(val,'x')..' '..player(val,'y'))
					
				end
			end
		end
	end
end
function StarWars.Players.Keys:logic()
	for ke, val in pairs(player(0,'tableliving')) do
		if self[val].attackState == true then
			StarWars.Players:shoot(val)
		end
	end
end
function StarWars.Players.Keys:init()
	for i = 1, 32 do
		self[i] = {}
		self[i].attackState = false
	end
end
function StarWars.Players.Control:init()
	for i = 1, 32 do
		self[i] = {}
		self[i].cooldown = 0
		self[i].recoil = 0
		
		self[i].reload = 0
		self[i].weapon = 0
		
		self[i].reloadHUDdev = 0
		self[i].reloadHUDMAX = 0
		self[i].reloadHUD_IMG = 0
		
	end
end
function StarWars.Players.Weapons:update(id)
	local weap = playerweapons(id)
	for ke, val in pairs(weap) do
		local nawol = false
		
		for k, va in pairs(self[id]) do
			if number_cheker(k) then
				if self[id][k] and val == self[id][k].Weaid then
					
					nawol = true
					break
				end
			end
		end
		if nawol == false then
			for kee, vall in pairs(StarWars.Weapons) do
				if number_cheker(kee) then
					if val == StarWars.Weapons[kee].Wea then
						local newid = #self[id]+1
						self[id][newid] = {}
						self[id][newid].Weaid = val
						self[id][newid].Ammo = StarWars.Weapons[kee].Score
						self[id][newid].Pocket = StarWars.Weapons[kee].Pocket
						self[id][newid].Mode = 0
						
						break
					end
				end
			end
		end
	end
end
function StarWars.Players.Weapons:clear_trash(id)
	
	local weap = playerweapons(id)
	for k, va in pairs(self[id]) do
		local nawol = false
		if number_cheker(k) then
			for ke, val in pairs(weap) do
				if self[id][k] and val == self[id][k].Weaid then
					nawol = true
					
					break
				end
			end
			if nawol == false then
				self[id][k] = nil
				
			end
		end
	end
end
function StarWars.Players.Weapons:del(id,typ)
	if not typ then
		--local weap = playerweapons(id)
		
		for k, va in pairs(self[id]) do
			if number_cheker(k) then
				if self[id][k]  then
					self[id][k] = nil
				end
			end
		end
		
	else
		for k, va in pairs(self[id]) do
			if number_cheker(k) then
				if self[id][k] and typ == self[id][k].Weaid then
					self[id][k] = nil
					
					break
				end
			end
		end
	end
end

function StarWars.Players.Weapons:drop(id,iid,typ,mod)
	for kee, vall in pairs(StarWars.Weapons) do
		if number_cheker(kee) then
			if typ == StarWars.Weapons[kee].Wea then
				local newid = #StarWars.DropedWeapons+1
				StarWars.DropedWeapons[newid] = {}
				StarWars.DropedWeapons[newid].idMap = iid
				StarWars.DropedWeapons[newid].Weaid = typ
				local govno = 0
				
				for k, va in pairs(StarWars.Players.Weapons[id]) do
					if number_cheker(k) and StarWars.Players.Weapons[id][k].Weaid == typ then
						govno = StarWars.Players.Weapons[id][k].Weaid
						StarWars.DropedWeapons[newid].Ammo = StarWars.Players.Weapons[id][k].Ammo
						StarWars.DropedWeapons[newid].Pocket = StarWars.Players.Weapons[id][k].Pocket
						break
					end
				end
				--StarWars.DropedWeapons[newid].Mode = self[kluh].Mode
				
				StarWars.Players.Weapons:del(id,typ)
				break
			end
		end
	end
end
function StarWars.Players.Weapons:equip(id,iid,typ,mod)
	local nawol = false
	
	for kee, vall in pairs(StarWars.DropedWeapons) do
		if number_cheker(kee) then
			
			if StarWars.DropedWeapons[kee].idMap == iid and StarWars.DropedWeapons[kee].Weaid == typ then
				nawol = true
				local newid = #StarWars.Players.Weapons[id]+1
				StarWars.Players.Weapons[id][newid] = {}
				StarWars.Players.Weapons[id][newid].Weaid = typ
				StarWars.Players.Weapons[id][newid].Ammo = StarWars.DropedWeapons[kee].Ammo
				StarWars.Players.Weapons[id][newid].Pocket = StarWars.DropedWeapons[kee].Pocket
				StarWars.Players.Weapons[id][newid].Mode = mod
				
				
				StarWars.DropedWeapons[kee] = nil
				
			end
		end
	end
	if nawol == false then
		for kee, vall in pairs(StarWars.Weapons) do
			if number_cheker(kee) then
				if StarWars.Weapons[kee].Wea == typ then
					local newid = #self[id]+1
					StarWars.Players.Weapons[id][newid] = {}
					StarWars.Players.Weapons[id][newid].Weaid = typ
					StarWars.Players.Weapons[id][newid].Ammo = StarWars.Weapons[kee].Score
					StarWars.Players.Weapons[id][newid].Pocket = StarWars.Weapons[kee].Pocket
					StarWars.Players.Weapons[id][newid].Mode = 0
					
				end
			end
		end
	end
end
function StarWars.DropedWeapons:clear(tip)
	if not tip then
		for kee, vall in pairs(self) do
			if number_cheker(kee) then
				self[kee] = nil
			end
		end
	else
		for kee, vall in pairs(self) do
			if number_cheker(kee) and not item(self[kee].idMap,'exists') then
				self[kee] = nil
			end
		end
	end
end
function StarWars.Players.Weapons:init()
	for i = 1, 32 do
		self[i] = {}
	end
end
function StarWars.Players.Control:logic()
	for i = 1, 32 do
		if self[i].cooldown > 0 then
			self[i].cooldown = self[i].cooldown - 1
		end
		if self[i].recoil > 0 then
			self[i].recoil = self[i].recoil - 1
		end
	end
end
function StarWars.ObjectHurt(id,iid,dmg)
	parse('damageobject '..id..' '..dmg..' '..iid)
end
function StarWars.Players:hurt(id,iid,dmg)
	local armor = player(id,'armor')
	local hp = player(id,'health')
	local procent = 1.0
	if player(id,'armor') == 201 then
		hp = hp - (dmg*0.75)
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg*0.75) end
	elseif player(id,'armor') == 202 then
		hp = hp - (dmg*0.50)
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg*0.50) end
	elseif player(id,'armor') == 203 then
		hp = hp - (dmg*0.25)
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg*0.25) end
	elseif player(id,'armor') == 204 then
		hp = hp - (dmg*0.50)
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg*0.50) end
	elseif player(id,'armor') == 205 then
		hp = hp - (dmg*0.05)
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg*0.05) end
	elseif player(id,'armor') == 206 then
		hp = hp - dmg
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg) end
	elseif player(id,'armor') > 0 then
		local dmgar = (dmg * 0.25) * 2.0
		dmg = dmg * StarWars.ArmorProcent
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg * StarWars.ArmorProcent) end
		while dmgar > 0 and armor > 0 do
			armor = armor - 2
			dmgar = dmgar - 1
		end
		
		dmg = dmg + (dmgar / 2)
		
		hp = hp - dmg
		
		if armor < 0 then
			armor = 0
		end
	else
		hp = hp - dmg
		if StarWars.Settings.function_hit then StarWars.Settings.function_hit(id,iid,dmg) end
	end
	if hp <= 0 then
		parse('customkill '..iid..' "Star Wars" '..id)
		parse('sv_soundpos "player/die'..math.random(1,3)..'.wav" '..player(id,'x')..' '..player(id,'y'))
	else
		parse('sethealth '..id..' '..hp)
		parse('setarmor '..id..' '..armor)
		parse('sv_soundpos "player/hit'..math.random(1,3)..'.wav" '..player(id,'x')..' '..player(id,'y'))
	end
end

function StarWars.Players.Control:standart(id)
	self[id].cooldown = 0
	self[id].recoil = 0
		
	self[id].reload = 0
	self[id].weapon = 0
end
function StarWars:Clear_Ammo()
	if StarWars.Settings.ClearAmmo == 1 then
		for ke, val in pairs(player(0,'tableliving')) do
			local weapons = {}
			for kee, vaa in pairs(playerweapons(val)) do
				for k, v in pairs(StarWars.Players.Weapons[val]) do
					if number_cheker(k) and StarWars.Players.Weapons[val][k].Weaid == vaa then
						local ammo, unno = playerammo(val,vaa)
						if ammo > 0 or unno > 0 then
							parse('setammo '..val..' '..vaa..' 0 0')
						end
					end
				end
			end
			
		end
	end
end
--========================================================================================================================
--==========================================================================================================================================
--========================================================================================================================
function StarWars.projectile_impact123(id,wea,x,y,mode,prid)
	if StarWars.Settings.Granade == 1 then
		if wea == 51 or wea == 53 then
			if wea == 51 then
				StarWars.IMG_EXPLOSION:Explosion(1,x,y,StarWars.HEimpuls_dmg,StarWars.HEimpuls_radius,id,{255,0,0})
				parse('effect "sparkles" '..x..' '..y..' 50 0 255 0 0')
			end
			if wea == 53 and mode == 100 then
				StarWars.SmokeStorm:SmokeActivator(x,y,id)
				--parse('freeprojectile '..id..' '..prid)
			end
		end
	end
end
function StarWars.projectile123(id,wea,x,y)
	if StarWars.Settings.Granade == 1 then
		if wea == 52 then
			if wea == 52 then
				StarWars.IMG_EXPLOSION:Explosion(2,x,y,StarWars.FLASHelec_dmgEMP,StarWars.FLASHelec_radius,id,{255,255,255})
				parse('effect "sparkles" '..x..' '..y..' 50 0 255 255 255')
			end
		end
	end
end
function StarWars.a123(id,mod)
	--StarWars.Players.Weapons:Switch_mode(id,mod,player(id,'weapontype'))
end
function StarWars.StarWars_alw()
	StarWars.Players.Control:logic()
	StarWars.Bullets:logic()
	StarWars.Players.Keys:logic()
	StarWars.Players.Control:Reload_progress()
	StarWars.Players.Control:HUD_reload_progress()
	StarWars.IMG_EXPLOSION:timers()
	StarWars:Clear_Ammo()
	StarWars.SmokeStorm:timeSmoke()
	if StarWars.TIME1 <= 0 then
		StarWars.TIME1 = 30
	else
		StarWars.TIME1 = StarWars.TIME1 - 1
	end
end
function StarWars.StarWars_startround_prespawn()
	StarWars.Bullets:clear(1)
	StarWars.DropedWeapons:clear()
	StarWars.Players.Control:init()
	StarWars.Players.Keys:init()
	StarWars.IMG_EXPLOSION:init()
	StarWars.SmokeStorm:clear()
	for ke, val in pairs(player(0,'tableliving')) do
		StarWars.Players.Weapons:clear_trash(val)
		StarWars.Players.Weapons:update(val)
	end
	--StarWars.Players.Weapons:init()
end
function StarWars.dr(id,iid,typ,_,_,mod)
	StarWars.Players.Weapons:drop(id,iid,typ,mod)
end
function StarWars.col(id,iid,typ,_,_,mod)
	
	StarWars.Players.Weapons:equip(id,iid,typ,mod)
end
function StarWars.kea(id,ke,st)
	if player(id, 'health') > 0 then
		StarWars.Players.Keys:press(id,ke,st)
	end
end
function StarWars.mss()
	for ke, val in pairs(player(0,'tableliving')) do
		StarWars.Players.Weapons:clear_trash(val)
		StarWars.Players.Weapons:update(val)
		--StarWars.HUDS:update(val) -- 1231232
	end
end
function StarWars.die123(id)
	dl123(id)
end
function StarWars.leave123(id)
	dl123(id)
end
function dl123(id)
	StarWars.Players.Control:standart(id)
	StarWars.HUDS:update(id)
end
function StarWars.select123(id)
	StarWars.HUDS:update(id)
end
function StarWars.second123()
	StarWars.DropedWeapons:clear(1)
end
StarWars.Players.Keys:init()
StarWars.Players.Control:init()
StarWars.Players.Weapons:init()